import java.lang.Math;

public class moduloArithmetik
{
	private int divisor;
	private static final boolean debug = true;
	
	moduloArithmetik(int divisor)
	{
		this.divisor = divisor;
	}
		
	public int betrag(int a)
	{ a = a%divisor;
		if (a < 0){
			return divisor + (a);
		}else{
			return (a);
		}
	}
	
	private int bt(int a)
	{
		return betrag(a);
	}	
	
	public int sum(int a, int b)
	{
		return bt(a + b);
		
	}
	
	public int sum(int a, int b, int c)
	{
		return bt(a + b + c);
		
	}
	
		
	public int diff(int a, int b)
	{
		return bt(a - b);
	}
	
		
		
	public int prod(int a, int b)
	{
		return bt(a * b);
	}
	
	public int multInvers(int a)
	{//*setzt voraus, dass "divisor" eine Primzahl ist!*/
		a = bt(a);
		for (int i = 1; i <= divisor; i++)
		{
			if (prod(a, i) == 1)
			{
				return i;
			}			
		}
		return 0;
	}
	
	public int quot(int a, int b)
	{
		return prod(bt(a), multInvers(b));
	}
	
	public int potenz(int a, int b)
	{
		/** errechnet a^b */
		if (b != 0)
		{
			int hilf = a;
			for (int i = 1; i < b; i++)
			{
				hilf = prod(hilf,a);
			}
			if (b >= 0){
				return hilf; 
			}else{
				return multInvers(hilf);
			}
		}else{
			if (a == 0){
				return 0;
			}else{
				return 1;
		}
		}
	}
	
	public int mod(int a)
	{
		return (a % divisor);
	}	

	public int getDivisor()
	{
		return this.divisor;
	}

	public void setDivisor(int divisor)
	{
		this.divisor = divisor;
	}
}// class end